;System ekspercki do wyboru gitary
;Autorzy: 
;Michal Przyszczypkowski 94357
;Jan Mizgajski

(deftemplate UI-state
   (slot id (default-dynamic (gensym*)))
   (slot wyswietl)
   (slot dodawana(default none))
   (slot response (default none))
   (multislot odpowiedzi)
   (slot state (default middle)))

   
(deftemplate state-list
   (slot current)
   (multislot sequence))
  
(deffacts startup
   (state-list))

(defrule system-banner
  =>
(assert (state running))
  (assert (UI-state (wyswietl "Witamy w systemie eksperckim do wyboru gitary")
                    (dodawana start)
                    (state initial)
                    (odpowiedzi))))

(defrule Typ
   (logical (start))
   =>
   (assert (UI-state (wyswietl "Gitara akustyczna czy elektryczna?")
                     (dodawana Typ)                   
                     (odpowiedzi Akustyczna Elektryczna))))

;---------
;Elektryki
;---------


(defrule Drewno
   (Typ Elektryczna)
   =>
   (assert (UI-state (wyswietl "Korpus z jakiego drewna?")
                     (dodawana Drewno)                   
                     (odpowiedzi Olcha Machon Jesion Egzotyczne Obojetnie))))


(defrule Drewno2
   (Drewno Obojetnie)
   =>
	(assert(Drewno Olcha)
	(Drewno Machon)
	(Drewno Jesion)
	(Drewno Egzotyczne)))


(defrule PodstrunicaE
   (Typ Elektryczna)
   =>
   (assert (UI-state (wyswietl "Podstrunica z jakiego drewna?")
                     (dodawana Podstrunica)                   
                     (odpowiedzi Klon Heban Rosewood Machon Obojetnie))))


(defrule PodstrunicaE2
   (Podstrunica Obojetnie)
   =>
	(assert(Podstrunica Klon)
	(Podstrunica Machon)
	(Podstrunica Heban)
	(Podstrunica Rosewood)))


(defrule Mostek00
   (Typ Elektryczna)
   =>
   (assert (UI-state (wyswietl "Jaki mostek?")
                     (dodawana MostekTyp)                   
                     (odpowiedzi Staly Ruchomy Obojetnie))))

(defrule Mostek01
   ?x<-(MostekTyp Staly)
   =>
  (retract ?x)
   (assert (UI-state (wyswietl "Jaki typ stalego mostka?")
                     (dodawana MostekTyp)
                     (odpowiedzi Strings-Through-Body Tune-O-Matic Obojetnie_jaki_staly))))

(defrule Mostek02
   ?x<-(MostekTyp Ruchomy)
   =>
   (retract ?x)
   (assert (UI-state (wyswietl "Jaki typ ruchomego mostka?")
                     (dodawana MostekTyp)
                     (odpowiedzi Floyd-Rose Fender-Style Obojetnie_jaki_ruchomy))))


(defrule Mostek03
   (MostekTyp Obojetnie_jaki_staly)
   =>
   (assert (MostekTyp Strings-Through-Body)
	   (MostekTyp Tune-O-Matic)))


(defrule Mostek04
   (MostekTyp Obojetnie_jaki_ruchomy)
   =>
   (assert (MostekTyp Floyd-Rose)
	   (MostekTyp Fender-Style)))


(defrule Mostek05
   (MostekTyp Obojetnie)
   =>
   (assert (MostekTyp Floyd-Rose)
	   (MostekTyp Fender-Style)
	   (MostekTyp Strings-Through-Body)
	   (MostekTyp Tune-O-Matic)))



(defrule Przystawki00
   (Typ Elektryczna)
   =>
   (assert (UI-state (wyswietl "Jakie przystawki?")
                     (dodawana PrzystawkiTyp)                   
                     (odpowiedzi Single Humbucker Mix Obojetnie))))

(defrule Przystawki01
   (Typ Elektryczna)
   ?x<-(PrzystawkiTyp Mix)
   =>
   (retract ?x)
   (assert (UI-state (wyswietl "Jaki uklad?")
                     (dodawana PrzystawkiTyp)                   
                     (odpowiedzi H-S-S H-S-H H-S Obojetnie_jaki_mix))))


(defrule Przystawki02
   (Typ Elektryczna)
   =>
   (assert (UI-state (wyswietl "Jaki producent przystawek?")
                     (dodawana PrzystawkiFirma)                   
                     (odpowiedzi EMG Seymour_Duncan Dimarzio Obojetnie_jaki_producent Inna))))


(defrule Przystawki03
   (Typ Elektryczna)
   (PrzystawkiTyp Humbucker)
   =>
   (assert (UI-state (wyswietl "Jaki zestawienie?")
                     (dodawana PrzystawkiTyp)                   
                     (odpowiedzi H-H H Obojetnie_jaki_zestaw_Humbucker`ow))))



(defrule Przystawki03a
   (Typ Elektryczna)
   (PrzystawkiTyp Single)
   =>
   (assert (UI-state (wyswietl "Jaki zestawienie?")
                     (dodawana PrzystawkiTyp)                   
                     (odpowiedzi S-S-S S-S S Obojetnie_jaki_zestaw_Single`i))))



(defrule Przystawki04
   (PrzystawkiFirma Obojetnie_jaki_producent)
   =>
   (assert (PrzystawkiFirma EMG)
	(PrzystawkiFirma Seymour_Duncan)
	(PrzystawkiFirma Dimarzio)
	(PrzystawkiFirma Inna)))



(defrule Przystawki05
   (PrzystawkiTyp Obojetnie_jaki_mix)
   =>
   (assert
	(PrzystawkiTyp H-S-S)
	(PrzystawkiTyp H-S-H)
	(PrzystawkiTyp H-S)))




(defrule Przystawki06
   (PrzystawkiTyp Obojetnie_jaki_zestaw_Humbucker`ow)
   =>
   (assert 
	(PrzystawkiTyp H-H)
	(PrzystawkiTyp H)))


(defrule Przystawki07
   (PrzystawkiTyp Obojetnie_jaki_zestaw_Single`i)
   =>
   (assert 
	(PrzystawkiTyp S)
	(PrzystawkiTyp S-S-S)
	(PrzystawkiTyp S-S)))


(defrule Przystawki08
   (PrzystawkiTyp Obojetnie)
   =>
   (assert (PrzystawkiTyp Obojetnie_jaki_zestaw_Single`i)
	   (PrzystawkiTyp Obojetnie_jaki_zestaw_Humbucker`ow)
	   (PrzystawkiTyp Obojetnie_jaki_mix)))




;--------
;Akustyki
;--------


(defrule DrewnoPrzod
   (Typ Akustyczna)
   =>
   (assert (UI-state (wyswietl "Przod z jakiego drewna?")
                     (dodawana DrewnoPrzod)                   
                     (odpowiedzi Swierk Machon Egzotyczne Obojetnie))))

(defrule DrewnoPrzod2
   (Typ Akustyczna)
   (DrewnoPrzod Obojetnie)
   =>
   (assert (DrewnoPrzod Swierk)
	   (DrewnoPrzod Egzotyczne)
	   (DrewnoPrzod Machon)))


(defrule Podstrunica
   (Typ Akustyczna)
   =>
   (assert (UI-state (wyswietl "Podstrunica z jakiego drewna?")
                     (dodawana Podstrunnica)                   
                     (odpowiedzi Heban Rosewood Inna Obojetnie))))

(defrule Podstrunica2
   (Typ Akustyczna)
   (Podstrunnica Obojetnie)
   =>
   (assert (Podstrunnica Heban)
	   (Podstrunnica Rosewood)
	   (Podstrunnica Inna)))


(defrule DrewnoTyl
   (Typ Akustyczna)
   =>
   (assert (UI-state (wyswietl "Boki i tyl z jakiego drewna?")
                     (dodawana DrewnoBokiTyl)                   
                     (odpowiedzi Rosewood Klon Machon Egzotyczne Obojetnie))))

(defrule DrewnoTyl2
   (Typ Akustyczna)
   (DrewnoBokiTyl Obojetnie)
   =>
   (assert (DrewnoBokiTyl Rosewood)
	   (DrewnoBokiTyl Klon)
	   (DrewnoBokiTyl Egzotyczne)
	   (DrewnoBokiTyl Machon)))


(defrule Struny00a
   (Typ Akustyczna)
   =>
   (assert (UI-state (wyswietl "Ile strun?")
                     (dodawana Struny)                   
                     (odpowiedzi 6 12 Obojetnie))))


(defrule Struny01a
   (Struny Obojetnie)
   =>
   (assert (Struny 6)
	   (Struny 12)))




(defrule Przetwornik
   (Typ Akustyczna)
   =>
   (assert (UI-state (wyswietl "Czy ma byc przetwornik?")
                     (dodawana Przetwornik)                   
                     (odpowiedzi Tak Brak Obojetnie))))



(defrule Przetwornik01
   (Typ Akustyczna)
   ?x<-(Przetwornik Tak)
   =>
   (retract ?x)
   (assert (UI-state (wyswietl "Jaki typ przetwornika?")
                     (dodawana Przetwornik)                   
                     (odpowiedzi LR_Bagg Martin CT4B 655CE Obojetnie_jaki_typ))))



(defrule Przetwornik02
   (Typ Akustyczna)
   (Przetwornik Obojetnie)
   =>
   (assert (Przetwornik Obojetnie_jaki_typ)
	   (Przetwornik Nie)))


(defrule Przetwornik03
   (Przetwornik Obojetnie_jaki_typ)
   (Typ Akustyczna)
   =>
   (assert (Przetwornik LR_Bagg)
	   (Przetwornik Martin)
	   (Przetwornik 655CE)
	   (Przetwornik CT4B)))


(defrule Wciecie1
   (Typ Akustyczna)
   =>
   (assert (UI-state (wyswietl "Czy ma byc wciecie?")
                     (dodawana Wciecie)                   
                     (odpowiedzi Tak Nie Obojetnie))))


(defrule Wciecie2
   (Typ Akustyczna)
   (Wciecie Obojetnie)
   =>
   (assert (Wciecie Tak)
	   (Wciecie Nie)))


;-------
;Results
;-------


;;Elektryki

(defrule gitara1 ""
	(Typ Elektryczna)
	(Drewno Olcha)
	(MostekTyp Strings-Through-Body)
	(PrzystawkiTyp H-H)
	(PrzystawkiFirma Seymour_Duncan)
	(Podstrunica Klon)
=>
(assert (UI-state (wyswietl "1")
			(state final))))

(defrule gitara2 ""
	(Typ Elektryczna)
	(Drewno Jesion)
	(MostekTyp Tune-O-Matic)
	(PrzystawkiTyp S-H)
	(PrzystawkiFirma Seymour_Duncan)
	(Podstrunica Klon)
=>
(assert (UI-state (wyswietl "2")
			(state final))))

(defrule gitara3 ""
	(Typ Elektryczna)
	(Drewno Olcha)
	(MostekTyp Floyd-Rose)
	(PrzystawkiTyp H-H)
	(PrzystawkiFirma EMG)
	(Podstrunica Klon)
=>
(assert (UI-state (wyswietl "3")
			(state final))))

(defrule gitara4 ""
	(Typ Elektryczna)
	(Drewno Olcha)
	(MostekTyp Floyd-Rose)
	(PrzystawkiTyp H)
	(PrzystawkiFirma EMG)
	(Podstrunica Heban)
=>
(assert (UI-state (wyswietl "4")
			(state final))))

(defrule gitara5 ""
	(Typ Elektryczna)
	(Drewno Olcha)
	(MostekTyp Fender-Style)
	(PrzystawkiTyp H-S-S)
	(PrzystawkiFirma Inna)
	(Podstrunica Rosewood)
=>
(assert (UI-state (wyswietl "5")
			(state final))))

(defrule gitara6 ""
	(Typ Elektryczna)
	(Drewno Machon)
	(MostekTyp Tune-O-Matic)
	(PrzystawkiTyp H-H)
	(PrzystawkiFirma Inna)
	(Podstrunica Rosewood)
=>
(assert (UI-state (wyswietl "6")
			(state final))))

(defrule gitara7 ""
	(Typ Elektryczna)
	(Drewno Olcha)
	(MostekTyp Floyd-Rose)
	(PrzystawkiTyp H-S-H)
	(PrzystawkiFirma Inna)
	(Podstrunica Heban)
=>
(assert (UI-state (wyswietl "7")
			(state final))))

(defrule gitara8 ""
	(Typ Elektryczna)
	(Drewno Olcha)
	(MostekTyp Fender-Style)
	(PrzystawkiTyp S-S-S)
	(PrzystawkiFirma Seymour_Duncan)
	(Podstrunica Rosewood)
=>
(assert (UI-state (wyswietl "8")
			(state final))))

(defrule gitara9 ""
	(Typ Elektryczna)
	(Drewno Machon)
	(MostekTyp Strings-Through-Body)
	(PrzystawkiTyp H-H)
	(PrzystawkiFirma EMG)
	(Podstrunica Klon)
=>
(assert (UI-state (wyswietl "9")
			(state final))))

(defrule gitara10 ""
	(Typ Elektryczna)
	(Drewno Olcha)
	(MostekTyp Strings-Through-Body)
	(PrzystawkiTyp H)
	(PrzystawkiFirma EMG)
	(Podstrunica Heban)
=>
(assert (UI-state (wyswietl "10")
			(state final))))

(defrule gitara11 ""
	(Typ Elektryczna)
	(Drewno Jesion)
	(MostekTyp Strings-Through-Body)
	(PrzystawkiTyp H-H)
	(PrzystawkiFirma Inna)
	(Podstrunica Rosewood)
=>
(assert (UI-state (wyswietl "11")
			(state final))))

(defrule gitara12 ""
	(Typ Elektryczna)
	(Drewno Egzotyczne)
	(MostekTyp Floyd-Rose)
	(PrzystawkiTyp H-H)
	(PrzystawkiFirma Inna)
	(Podstrunica Klon)
=>
(assert (UI-state (wyswietl "12")
			(state final))))

(defrule gitara13 ""
	(Typ Elektryczna)
	(Drewno Egzotyczne)
	(MostekTyp Tune-O-Matic)
	(PrzystawkiTyp H-H)
	(PrzystawkiFirma Inna)
	(Podstrunica Machon)
=>
(assert (UI-state (wyswietl "13")
			(state final))))

(defrule gitara14 ""
	(Typ Elektryczna)
	(Drewno Machon)
	(MostekTyp Tune-O-Matic)
	(PrzystawkiTyp H-S)
	(PrzystawkiFirma Inna)
	(Podstrunica Rosewood)
=>
(assert (UI-state (wyswietl "14")
			(state final))))

(defrule gitara15 ""
	(Typ Elektryczna)
	(Drewno Egzotyczne)
	(MostekTyp Tune-O-Matic)
	(PrzystawkiTyp H)
	(PrzystawkiFirma Inna)
	(Podstrunica Machon)
=>
(assert (UI-state (wyswietl "15")
			(state final))))

(defrule gitara16 ""
	(Typ Elektryczna)
	(Drewno Egzotyczne)
	(MostekTyp Floyd-Rose)
	(PrzystawkiTyp H-S-H)
	(PrzystawkiFirma Inna)
	(Podstrunica Rosewood)
=>
(assert (UI-state (wyswietl "16")
			(state final))))

(defrule gitara17 ""
	(Typ Elektryczna)
	(Drewno Olcha)
	(MostekTyp Floyd-Rose)
	(PrzystawkiTyp H-S-S)
	(PrzystawkiFirma Dimarzio)
	(Podstrunica Machon)
=>
(assert (UI-state (wyswietl "17")
			(state final))))

(defrule gitara18 ""
	(Typ Elektryczna)
	(Drewno Egzotyczne)
	(MostekTyp Floyd-Rose)
	(PrzystawkiTyp H-S-H)
	(PrzystawkiFirma Dimarzio)
	(Podstrunica Klon)
=>
(assert (UI-state (wyswietl "18")
			(state final))))

(defrule gitara19 ""
	(Typ Elektryczna)
	(Drewno Olcha)
	(MostekTyp Floyd-Rose)
	(PrzystawkiTyp H-S-H)
	(PrzystawkiFirma Dimarzio)
	(Podstrunica Klon)
=>
(assert (UI-state (wyswietl "19")
			(state final))))

;; Akustyki

(defrule gitara20 ""
	(DrewnoPrzod Swierk)
	(DrewnoBokiTyl Machon)
	(Przetwornik Brak)
	(Struny 6)
	(Wciecie Nie)
	(Podstrunnica Inna)
=>
(assert (UI-state (wyswietl "20")
			(state final))))

(defrule gitara21 ""
	(DrewnoPrzod Swierk)
	(DrewnoBokiTyl Rosewood)
	(Przetwornik Brak)
	(Struny 6)
	(Wciecie Nie)
	(Podstrunnica Rosewood)
=>
(assert (UI-state (wyswietl "21")
			(state final))))

(defrule gitara22 ""
	(DrewnoPrzod Swierk)
	(DrewnoBokiTyl Egzotyczne)
	(Przetwornik Brak)
	(Struny 6)
	(Wciecie Nie)
	(Podstrunnica Heban)
=>
(assert (UI-state (wyswietl "22")
			(state final))))

(defrule gitara23 ""
	(DrewnoPrzod Machon)
	(DrewnoBokiTyl Machon)
	(Przetwornik Brak)
	(Struny 6)
	(Wciecie NIe)
	(Podstrunnica Rosewood)
=>
(assert (UI-state (wyswietl "23")
			(state final))))

(defrule gitara24 ""
	(DrewnoPrzod Swierk)
	(DrewnoBokiTyl Egzotyczne)
	(Przetwornik Brak)
	(Struny 6)
	(Wciecie Nie)
	(Podstrunnica Rosewood)
=>
(assert (UI-state (wyswietl "24")
			(state final))))

(defrule gitara25 ""
	(DrewnoPrzod Egzotyczne)
	(DrewnoBokiTyl Egzotyczne)
	(Przetwornik Brak)
	(Struny 6)
	(Wciecie Nie)
	(Podstrunnica Heban)
=>
(assert (UI-state (wyswietl "25")
			(state final))))

(defrule gitara26 ""
	(DrewnoPrzod Swierk)
	(DrewnoBokiTyl Machon)
	(Przetwornik LR_Bagg)
	(Struny 6)
	(Wciecie Tak)
	(Podstrunnica Rosewood)
=>
(assert (UI-state (wyswietl "26")
			(state final))))

(defrule gitara27 ""
	(DrewnoPrzod Machon)
	(DrewnoBokiTyl Machon)
	(Przetwornik Martin)
	(Struny 6)
	(Wciecie Nie)
	(Podstrunnica Inna)
=>
(assert (UI-state (wyswietl "27")
			(state final))))

(defrule gitara28 ""
	(DrewnoPrzod Swierk)
	(DrewnoBokiTyl Machon)
	(Przetwornik CT4B)
	(Struny 6)
	(Wciecie Tak)
	(Podstrunnica Rosewood)
=>
(assert (UI-state (wyswietl "28")
			(state final))))

(defrule gitara29 ""
	(DrewnoPrzod Swierk)
	(DrewnoBokiTyl Machon)
	(Przetwornik Brak)
	(Struny 12)
	(Wciecie Nie)
	(Podstrunnica Rosewood)
=>
(assert (UI-state (wyswietl "29")
			(state final))))

(defrule gitara30 ""
	(DrewnoPrzod Swierk)
	(DrewnoBokiTyl Klon)
	(Przetwornik 655CE)
	(Struny 12)
	(Wciecie Tak)
	(Podstrunnica Heban)
=>
(assert (UI-state (wyswietl "30")
			(state final))))




;--------
;NORESULT
;--------

(defrule noresult
  (declare (salience -10))
  (logical (UI-state (id ?id)))
  (state-list (current ?id))   
  => 
  (assert (UI-state (wyswietl "error")
           (state final)))) 



;;;*************************
;;;* GUI INTERACTION RULES *
;;;*************************

(defrule ask-question
   (declare (salience 5))
   (UI-state (id ?id))  
   ?f <- (state-list (sequence $?s&:(not (member$ ?id ?s))))             
   =>   
   (modify ?f (current ?id)
              (sequence ?id ?s))   
   (halt))

(defrule handle-next-no-change-none-middle-of-chain
   (declare (salience 10))
   ?f1 <- (next ?id)
   ?f2 <- (state-list (current ?id) (sequence $? ?nid ?id $?))                     
   =>    
   (retract ?f1)
   (modify ?f2 (current ?nid))   
   (halt))

(defrule handle-next-response-none-end-of-chain
   (declare (salience 10))   
   ?f <- (next ?id)
   (state-list (sequence ?id $?))   
   (UI-state (id ?id)
             (dodawana ?relation))                   
   =>      
   (retract ?f)
   (assert (add-response ?id)))   

(defrule handle-next-no-change-middle-of-chain
   (declare (salience 10))   
   ?f1 <- (next ?id ?response)
   ?f2 <- (state-list (current ?id) (sequence $? ?nid ?id $?))     
   (UI-state (id ?id) (response ?response))   
   =>      
   (retract ?f1)   
   (modify ?f2 (current ?nid))   
   (halt))

(defrule handle-next-change-middle-of-chain
   (declare (salience 10))   
   (next ?id ?response)
   ?f1 <- (state-list (current ?id) (sequence ?nid $?b ?id $?e))     
   (UI-state (id ?id) (response ~?response))   
   ?f2 <- (UI-state (id ?nid))   
   =>         
   (modify ?f1 (sequence ?b ?id ?e))   
   (retract ?f2))
   
(defrule handle-next-response-end-of-chain
   (declare (salience 10))   
   ?f1 <- (next ?id ?response)   
   (state-list (sequence ?id $?))   
   ?f2 <- (UI-state (id ?id)
                    (response ?expected)
                    (dodawana ?relation))                
   =>      
   (retract ?f1)
   (if (neq ?response ?expected)
      then
      (modify ?f2 (response ?response)))      
   (assert (add-response ?id ?response)))   

(defrule handle-add-response
   (declare (salience 10))   
   (logical (UI-state (id ?id)
                      (dodawana ?relation)))   
   ?f1 <- (add-response ?id ?response)                
   =>      
   (str-assert (str-cat "(" ?relation " " ?response ")"))   
   (retract ?f1))   

(defrule handle-add-response-none
   (declare (salience 10))   
   (logical (UI-state (id ?id)
                      (dodawana ?relation)))   
   ?f1 <- (add-response ?id)                
   =>      
   (str-assert (str-cat "(" ?relation ")"))   
   (retract ?f1))   

(defrule handle-prev
   (declare (salience 10))      
   ?f1 <- (prev ?id)   
   ?f2 <- (state-list (sequence $?b ?id ?p $?e))                
   =>   
   (retract ?f1)   
   (modify ?f2 (current ?p))   
   (halt))