; sterowanie

(deftemplate currentState
	(slot state (default none))
	(slot text)		
	(slot choiceType (default radioButton))
	(multislot choices)
	(multislot selected)
)

(deftemplate result
	(slot name (default none))
	(slot description)
	(slot image (default none))
)

; stan pocztkowy
(defrule WelcomeState
	=>
	(assert	(currentState 
		(state start)
		(text WELCOME))
	)
)

; stan kocowy - brak wynikw
(defrule EndOfQuestions
	?state<-(currentState)
	(end)
	=>
	(retract ?state) 
	(assert (currentState
		(state final)	
		(text RESULTS)
	))
)

; umiejsowienie: przd/ty
(defrule locationSelect
	?state<-(currentState)
	(not(locationSelected))
	=>
	(retract ?state) 
	(assert (locationSelected))	
	(assert (currentState
		(state location)
		(text LOCATION)
		(choices FRONT REAR)	
		(selected FRONT)
	))
)

; liczba i rodzaj diod lampki tylnej
(defrule rearLEDSelect
	?state<-(currentState)
	(not(rearLEDSelected))
	(location REAR)
	=>
	(retract ?state) 
	(assert (rearLEDSelected))	
	(assert (currentState
		(state rearLED)
		(text REAR_LED)
		(choiceType checkBox)
		(choices REAR_POW1 REAR_POW2 REAR_POW3)	
		(selected REAR_POW1 REAR_POW2 REAR_POW3)
	))
)

; cena lampki tylnej
(defrule rearPriceSelect
	?state<-(currentState)
	(not(rearPriceSelected))
	(location REAR)
	=>
	(retract ?state) 
	(assert (rearPriceSelected))	
	(assert (currentState
		(state rearPrice)
		(text REAR_PRICE)
		(choiceType checkBox)
		(choices REAR_PINT1 REAR_PINT2 REAR_PINT3)	
		(selected REAR_PINT1 REAR_PINT2 REAR_PINT3)
	))
	(assert (end))
)

; przeznaczenie lampki przedniej
(defrule purposeSelect
	?state<-(currentState)
	(not(purposeSelected))
	(location FRONT)
	=>
	(retract ?state) 
	(assert (purposeSelected))	
	(assert (currentState
		(state purpose)
		(text PURPOSE)
		(choiceType checkBox)
		(choices CITY ROADS FOREST OFFROAD)	
		(selected CITY ROADS FOREST OFFROAD)
	))
)

; aluminiowa obudowa
(defrule aluBodySelect
	?state<-(currentState)
	(not(aluBodySelected))
	(location FRONT)
	(purpose FOREST | OFFROAD)
	=>
	(retract ?state) 
	(assert (aluBodySelected))	
	(assert (currentState
		(state aluBody)
		(text ALU_BODY)
		(choices YES NO)	
		(selected NO)
	))
)

; zasilanie
(defrule poweringSelect
	?state<-(currentState)
	(not(poweringSelected))
	(location FRONT)
	=>
	(retract ?state) 
	(assert (poweringSelected))	
	(assert (currentState
		(state powering)
		(text POWERING)
		(choiceType checkBox)
		(choices AA AAA ACU_18650 ACU_INCL CR2032)	
		(selected AA AAA ACU_18650 ACU_INCL CR2032)
	))
)

; adowarka
(defrule chargerSelect
	?state<-(currentState)
	(not(chargerSelected))
	(location FRONT)
	(powering AA|AAA)
	=>
	(retract ?state) 
	(assert (chargerSelected))	
	(assert (currentState
		(state charger)
		(text CHARGER)
		(choices YES NO)	
		(selected NO)
	))
)

; kabel usb zamiast adowarki
(defrule usbCableSelect
	?state<-(currentState)
	(not(usbCableSelected))
	(location FRONT)
	(powering ACU_INCL)
	=>
	(retract ?state) 
	(assert (usbCableSelected))	
	(assert (currentState
		(state usbCable)
		(text USB_CABLE)
		(choices YES NO)	
		(selected NO)
	))
)

; wiato pozycyjne
(defrule positionLightSelect
	?state<-(currentState)
	(not(positionLightSelected))
	(location FRONT)
	(purpose CITY)
	(not(purpose FOREST))
	(not(purpose OFFROAD))
	=>
	(retract ?state) 
	(assert (positionLightSelected))	
	(assert (currentState
		(state positionLight)
		(text POSITION_LIGHT)
		(choices YES NO)	
		(selected NO)
	))
)

; mocowanie do kasku
(defrule helmetMountSelect
	?state<-(currentState)
	(not(helmetMountSelected))
	(location FRONT)
	(purpose OFFROAD)
	(modes YES)
	(frontPrice BTW_200_400 | MIN_400)
	=>
	(retract ?state) 
	(assert (helmetMountSelected))	
	(assert (currentState
		(state helmetMount)
		(text HELMET_MOUNT)
		(choices YES NO)	
		(selected NO)
	))
)

; cena lampki przedniej
(defrule frontPriceSelect
	?state<-(currentState)
	(not(frontPriceSelected))
	(location FRONT)
	=>
	(retract ?state) 
	(assert (frontPriceSelected))	
	(assert (currentState
		(state frontPrice)
		(text FRONT_PRICE)
		(choiceType checkBox)
		(choices MAX_50 BTW_50_100 BTW_100_200 BTW_200_400 MIN_400)	
		(selected MAX_50 BTW_50_100 BTW_100_200)
	))
)

; liczba trybw
(defrule modesSelect
	?state<-(currentState)
	(not(modesSelected))
	(location FRONT)
	=>
	(retract ?state) 
	(assert (modesSelected))	
	(assert (currentState
		(state modes)
		(text MODES)
		(choices YES NO)	
		(selected NO)
	))
)

; tryb migajcy
(defrule flashingModeSelect
	?state<-(currentState)
	(not(flashingModeSelected))
	(location FRONT)
	(modes YES)
	=>
	(retract ?state) 
	(assert (flashingModeSelected))	
	(assert (currentState
		(state flashingMode)
		(text FLASHING_MODE)
		(choices YES NO)	
		(selected NO)
	))
)

; moduowa budowa
(defrule modularitySelect
	?state<-(currentState)
	(not(modularitySelected))
	(location FRONT)
	(weight BTW_100_200g | MTH_200g)
	(frontPrice BTW_200_400 | MIN_400)
	=>
	(retract ?state) 
	(assert (modularitySelected))	
	(assert (currentState
		(state modularity)
		(text MODULARITY)
		(choices YES NO)	
		(selected NO)
	))
)

; waga lampki przedniej
(defrule weightSelect
	?state<-(currentState)
	(not(weightSelected))
	(location FRONT)
	=>
	(retract ?state) 
	(assert (weightSelected))	
	(assert (currentState
		(state weight)
		(text WEIGHT)
		(choiceType checkBox)
		(choices MAX_100g BTW_100_200g MTH_200g)	
		(selected MAX_100g BTW_100_200g)
	))
)

; czas wiecenia
(defrule burnTimeSelect
	?state<-(currentState)
	(not(burnTimeSelected))
	(location FRONT)
	=>
	(retract ?state) 
	(assert (burnTimeSelected))	
	(assert (currentState
		(state burnTime)
		(text BURN_TIME)
		(choiceType checkBox)
		(choices TO_2h BTW_2_3h BTW_3_10h MTH_10h)	
		(selected TO_2h BTW_2_3h BTW_3_10h MTH_10h)
	))
	(assert (end))
)