;
;                   PAKOWANIE
;   Pakuj pakuj pakuj pakuj pakuj. Pakuj.
;   Autorzy:
;    * Konrad Miazga 99075
;    * Mikoaj Bajek 99409
;
;


(deftemplate UI-state
    (slot display)
    (slot relation-asserted (default none))
    (slot answer-type (default radiobutton))
    (multislot items (default ))
    (multislot answers)
    (slot state (default middle)))



;*************************************************

(defrule startup-r ""
(not(start))
 =>
 (assert (UI-state (display Powitanie)
                   (relation-asserted start)
                   (answers)
                   (state initial))))


;*************************************************

(defrule nocleg-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (not(nocleg))
=>
    (retract ?state)
    (assert (nocleg))
    (assert (UI-state (display NoclegPytanie)
                      (relation-asserted nocleg)
                      (answers Tak Nie))))

(defrule gdzie-nocleg-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (nocleg Tak)
    (not(gdzie-nocleg))
=>
    (retract ?state)
    (assert (gdzie-nocleg))
    (assert (UI-state (display GdzieNoclegPytanie)
                      (relation-asserted gdzie-nocleg)
                      (answers Pensjonat Rodzina Namiot))))

(defrule czy-oplacony-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (gdzie-nocleg Pensjonat)
    (not(czy-oplacony))
=>
    (retract ?state)
    (assert (czy-oplacony))
    (assert (UI-state (display CzyOplaconyPytanie)
                      (relation-asserted czy-oplacony)
                      (answers Tak Nie ))))

(defrule dlugosc-wyjazdu-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (nocleg Tak)
    (not(dlugosc-wyjazdu))
=>
    (retract ?state)
    (assert (dlugosc-wyjazdu))
    (assert (UI-state (display DlugoscWyjazduPytanie)
                      (relation-asserted dlugosc-wyjazdu)
                      (answers Krotki Dlugi))))

(defrule pora-roku-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (not(pora-roku))
=>
    (retract ?state)
    (assert (pora-roku))
    (assert (UI-state (display PoraRokuPytanie)    
                      (relation-asserted pora-roku)
                      (answers Wiosna Lato Jesien Zima))))

(defrule srodek-transportu-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (not(srodek-transportu))
=>
    (retract ?state)
    (assert (srodek-transportu))
    (assert (UI-state (display SrodekTransportuPytanie)
                      (relation-asserted srodek-transportu)
                      (answers Rower Samochod Pociag Autobus Samolot ))))

(defrule czas-wolny-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (not(czas-wolny))
=>
    (retract ?state)
    (assert (czas-wolny))
    (assert (UI-state (display CzasWolnyPytanie)
                      (relation-asserted czas-wolny)
                      (answers Duzo Malo))))

(defrule przyjmuje-leki-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (not(przyjmuje-leki))
=>
    (retract ?state)
    (assert (przyjmuje-leki))
    (assert (UI-state (display PrzyjmujeLekiPytanie)
                      (relation-asserted przyjmuje-leki)
                      (answers Tak Nie))))

(defrule natura-wyjazdu-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (not(natura-wyjazdu))
=>
    (retract ?state)
    (assert (natura-wyjazdu))
    (assert (UI-state (display NaturaWyjazduPytanie)
                      (relation-asserted natura-wyjazdu)
                      (answers Turystyczny Rodzinny Biznesowy Rekolekcje))))

(defrule dokad-wyjazd-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (natura-wyjazdu Turystyczny)
    (not(dokad-wyjazd))
=>
    (retract ?state)
    (assert (dokad-wyjazd))
    (assert (UI-state (display DokadWyjazdPytanie)
                      (relation-asserted dokad-wyjazd)
                      (answers Gory Morze Miasto Inne))))

(defrule czy-narty-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (dokad-wyjazd Gory)    
    (pora-roku Zima)
    (not(czy-narty))
=>
    (retract ?state)
    (assert (czy-narty))
    (assert (UI-state (display CzyNartyPytanie)
                      (relation-asserted czy-narty)
                      (answers Tak Nie))))

(defrule czy-animator-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (natura-wyjazdu Rekolekcje)
    (not(czy-animator))
=>
    (retract ?state)
    (assert (czy-animator))
    (assert (UI-state (display CzyAnimatorPytanie)
                      (relation-asserted czy-animator)
                      (answers Tak Nie))))

(defrule czy-zagranica-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (not(czy-zagranica))
=>
    (retract ?state)
    (assert (czy-zagranica))
    (assert (UI-state (display CzyZagranicaPytanie)
                      (relation-asserted czy-zagranica)
                      (answers Tak Nie))))


(defrule czy-duzy-bagaz-r ""
    (declare (salience 10))
    ?state<-(UI-state)
    (srodek-transportu ~Rower)
    (not(czy-duzy-bagaz))
=>
    (retract ?state)
    (assert (czy-duzy-bagaz))
    (assert (UI-state (display CzyDuzyBagaz)
                      (relation-asserted czy-duzy-bagaz)
                      (answers Tak Nie))))


;*************************************************

(defrule laptop-w ""
	?state<-(UI-state (items $?p))
	(czy-duzy-bagaz Tak)	
	(czas-wolny Duzo)
	(not(laptop))
=>
	(retract ?state)
	(assert (laptop))
	(assert (UI-state (display none)
					  (answers)
					  (items Laptop Zasilacz $?p)
					  (state final))))


(defrule opalanie-w ""
	?state<-(UI-state (items $?p))
	(dokad-wyjazd Morze | Gory)	
	(pora-roku Lato | Wiosna)
	(not(opalanie))
=>
	(retract ?state)
	(assert (opalanie))
	(assert (UI-state (display none)
					  (answers)
					  (items OlejekDoOpalania $?p)
					  (state final))))

(defrule morze-w ""
	?state<-(UI-state (items $?p))
	(dokad-wyjazd Morze)	
	(pora-roku Lato | Wiosna)
	(not(morze))
=>
	(retract ?state)
	(assert (morze))
	(assert (UI-state (display none)
					  (answers)
					  (items Recznik StrojKapielowy $?p)
					  (state final))))

(defrule komary-w ""
	?state<-(UI-state (items $?p))
	(dokad-wyjazd Las)	
	(pora-roku Lato | Wiosna)
	(not(komary))
=>
	(retract ?state)
	(assert (komary))
	(assert (UI-state (display none)
					  (answers)
					  (items Off $?p)
					  (state final))))

;***

(defrule gory-w ""
	?state<-(UI-state (items $?p))
	(dokad-wyjazd Gory)
	(not(gory))
=>
	(retract ?state)
	(assert (gory))
	(assert (UI-state (display none)
					  (answers)
					  (items MapaGorska ButyTrekingowe Kurtka $?p)
					  (state final))))

(defrule namiot-w ""
	?state<-(UI-state (items $?p))
	(gdzie-nocleg Namiot)
	(not(namiot))
=>
	(retract ?state)
	(assert (namiot))
	(assert (UI-state (display none)
					  (answers)
					  (items Namiot Spiwor $?p)
					  (state final))))

(defrule zagranica-w ""
	?state<-(UI-state (items $?p))
	(czy-zagranica Tak)
	(not(zagranica))
=>
	(retract ?state)
	(assert (zagranica))
	(assert (UI-state (display none)
					  (answers)
					  (items Paszport Ubezpieczenie $?p)
					  (state final))))


(defrule kosmetyki-w ""
	?state<-(UI-state (items $?p))
	(gdzie-nocleg ~Rodzina )
	(natura-wyjazdu ~Rodzinny)
	(not(kosmetyki))
=>
	(retract ?state)
	(assert (kosmetyki))
	(assert (UI-state (display none)
					  (answers)
					  (items Szampon PastaDoZebow $?p)
					  (state final))))

(defrule kasa-hotel-w ""
	?state<-(UI-state (items $?p))
	(czy-oplacony Nie )
	(not(kasa-hotel))
=>
	(retract ?state)
	(assert (kasa-hotel))
	(assert (UI-state (display none)
					  (answers)
					  (items KasaNaHotel $?p)
					  (state final))))

(defrule bliety-w ""
	?state<-(UI-state (items $?p))
	(srodek-transportu Pociag | Autobus | Samolot )
	(not(bilety))
=>
	(retract ?state)
	(assert (bilety))
	(assert (UI-state (display none)
					  (answers)
					  (items Bilety $?p)
					  (state final))))

(defrule wolne-w ""
	?state<-(UI-state (items $?p))
	(czas-wolny Duzo  )
	(not(wolne))
=>
	(retract ?state)
	(assert (wolne ))
	(assert (UI-state (display none)
					  (answers)
					  (items Ksiazka $?p)
					  (state final))))

(defrule samochodowy-w ""
	?state<-(UI-state (items $?p))
	(srodek-transportu Samochod  )
	(not(samochodowy))
=>
	(retract ?state)
	(assert (samochodowy ))
	(assert (UI-state (display none)
					  (answers)
					  (items Nawigacja PrawoJazdy DowodRej $?p)
					  (state final))))

(defrule rowerowy-w ""
	?state<-(UI-state (items $?p))
	(srodek-transportu Rower )
	(not(rowerowy))
=>
	(retract ?state)
	(assert (rowerowy ))
	(assert (UI-state (display none)
					  (answers)
					  (items Przypiecie Mapa Detki Pompka $?p)
					  (state final))))

(defrule dlugi-rowerowy-w ""
	?state<-(UI-state (items $?p))
	(srodek-transportu Rower )
	(dlugosc-wyjazdu Dlugi )
	(not(dlugi-rowerowy))
=>
	(retract ?state)
	(assert (dlugi-rowerowy))
	(assert (UI-state (display none)
					  (answers)
					  (items Apteczka Narzedzia Smar $?p)
					  (state final))))	

(defrule na-narty-w ""
	?state<-(UI-state (items $?p))
	(czy-narty Tak )
	(not(na-narty))
=>
	(retract ?state)
	(assert (na-narty ))
	(assert (UI-state (display none)
					  (answers)
					  (items Narty Kije ButyNarciarskie Termos $?p)
					  (state final))))	

(defrule leki-w ""
	?state<-(UI-state (items $?p))
	(przyjmuje-leki Tak )
	(not(leki))
=>
	(retract ?state)
	(assert (leki ))
	(assert (UI-state (display none)
					  (answers)
					  (items Leki $?p)
					  (state final))))

(defrule rekolekcje-w ""
	?state<-(UI-state (items $?p))
	(natura-wyjazdu Rekolekcje )
	(not(rekolekcje))
=>
	(retract ?state)
	(assert (rekolekcje ))
	(assert (UI-state (display none)
					  (answers)
					  (items PismoSw Rozaniec $?p)
					  (state final))))

(defrule animator-w ""
	?state<-(UI-state (items $?p))
	(czy-animator Tak )
	(not(animator))
=>
	(retract ?state)
	(assert (animator ))
	(assert (UI-state (display none)
					  (answers)
					  (items Swieczka Zapalki Konspekty $?p)
					  (state final))))

(defrule garnitur-w ""
	?state<-(UI-state (items $?p))
	(natura-wyjazdu Biznesowy | Rekolekcje )
	(not(garnitur))
=>
	(retract ?state)
	(assert (garnitur ))
	(assert (UI-state (display none)
					  (answers)
					  (items Garnitur $?p)
					  (state final))))
				
				
;*************************************************

(defrule brak ""
    (declare (salience -10))
    ?state<-(UI-state(state ~final))
    (not(brak))
=>
    (retract ?state)
    (assert(brak))
    (assert (UI-state (display Brak)
                      (answers)
                      (state final))))

