package pakowanie;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import CLIPSJNI.*;


public class Pakowanie implements ActionListener {

    JPanel choicesPanel;
    JButton nextButton;
    JLabel text;
    ButtonGroup choicesButtons;
    JFrame mainFrame;

    Environment clips;
    ResourceBundle res;
    String relationAsserted;
    String lastRelationAsserted="";

    public Pakowanie()
    {
        try{
			
            res = ResourceBundle.getBundle("PakowanieResources");
            mainFrame = new JFrame(res.getString("Title"));
            mainFrame.setSize(400,300);
            mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
            mainFrame.getContentPane().setLayout(new BoxLayout(mainFrame.getContentPane(), BoxLayout.Y_AXIS));

            nextButton = new JButton(res.getString("Next"));
            text = new JLabel();
            
            choicesButtons = new ButtonGroup();
            choicesPanel = new JPanel();

            JPanel buttonPanel = new JPanel();
            buttonPanel.add(nextButton);
            nextButton.addActionListener(this);
            nextButton.setActionCommand("Next");

            text.setAlignmentX(JLabel.CENTER_ALIGNMENT);
            text.setHorizontalAlignment(JLabel.CENTER);
            mainFrame.getContentPane().add(Box.createRigidArea(new Dimension(0, 20)));
            mainFrame.getContentPane().add(text);
            mainFrame.getContentPane().add(Box.createRigidArea(new Dimension(0, 10)));
            mainFrame.getContentPane().add(choicesPanel);
            mainFrame.getContentPane().add(Box.createRigidArea(new Dimension(0, 10)));
            mainFrame.getContentPane().add(buttonPanel);
            
            clips = new Environment();
            clips.load("pakowanie.clp");
            clips.reset();
            clips.run(1);
            

            mainFrame.setVisible(true);
            nextUIState();
        }
        catch(MissingResourceException e)
        {
            e.printStackTrace();
            return;
        }
    }


    public void actionPerformed(ActionEvent e)
    {
        if (e.getActionCommand().equals("Next"))
        {
            int count = 0;
            for(int i = 0; i < choicesPanel.getComponentCount(); i++)
            {
                if(((JToggleButton)choicesPanel.getComponent(i)).isSelected())
                {
                    clips.assertString("(" +relationAsserted+" "+((JToggleButton)choicesPanel.getComponent(i)).getActionCommand()+")");
                    System.out.println("(" +relationAsserted+" "+((JToggleButton)choicesPanel.getComponent(i)).getActionCommand()+")");
                    count++;
                }
            }
            if(choicesPanel.getComponentCount() != 0 && count == 0)
            {
                JOptionPane.showMessageDialog(null, res.getString("NoInputMessage"), res.getString("NoInputTitle"), JOptionPane.ERROR_MESSAGE);
                return;
            }
            clips.run(1);
            nextUIState();
        }
        else if (e.getActionCommand().equals("Reset"))
	{
            clips.reset();
            clips.run(1);
            nextUIState();
	}
    }
    
    private void nextUIState()
    {
        String evalStr = "(find-all-facts ((?f UI-state)) TRUE)";

        MultifieldValue pv = (MultifieldValue) clips.eval(evalStr);

        FactAddressValue fv = (FactAddressValue) pv.listValue().get(0);
        relationAsserted = fv.getFactSlot("relation-asserted").toString();

	if (relationAsserted.contentEquals(lastRelationAsserted))
        {
            clips.run(1);
	    nextUIState();
	    return;
	}
        lastRelationAsserted = relationAsserted;

	if (fv.getFactSlot("state").toString().equals("final"))
	{
            choicesPanel.removeAll();
            choicesButtons = null;

            text.setText("<html><center>" + res.getString("Wyniki") + "</center></html>");

            nextButton.setActionCommand("Reset");
	    nextButton.setText(res.getString("Reset"));

            if(fv.getFactSlot("display").toString().equals("Brak"))
            {
                text.setText("<html><center>"+res.getString("Brak")+"</center></html>");
                choicesPanel.repaint();
                return;
            }
            
            clips.run();
            showResults();
            
            return;
	}
	else if (fv.getFactSlot("state").toString().equals("initial"))
	{
            nextButton.setActionCommand("Next");
	    nextButton.setText(res.getString("Next"));
	}
	else
	{
            nextButton.setActionCommand("Next");
	    nextButton.setText(res.getString("Next"));
	}

	choicesPanel.removeAll();
	choicesButtons = new ButtonGroup();

	pv = (MultifieldValue) fv.getFactSlot("answers");

	java.util.List list = pv.listValue();

	String answerType =  fv.getFactSlot("answer-type").toString();

	for (Iterator itr = list.iterator(); itr.hasNext();)
	{
            PrimitiveValue bv = (PrimitiveValue) itr.next();

            if(answerType.equalsIgnoreCase("checkbox"))
            {
                JCheckBox c = new JCheckBox(res.getString(bv.toString()));
                c.setActionCommand(bv.toString());
                choicesPanel.add(c);
            }
            else{
                JRadioButton r = new JRadioButton(res.getString(bv.toString()));
                r.setActionCommand(bv.toString());
                choicesPanel.add(r);
                choicesButtons.add(r);
            }
	}

	choicesPanel.repaint();

	String txt = "<html><center>" + res.getString(((SymbolValue) fv.getFactSlot("display")).stringValue()) + "</center></html>";
        text.setText(txt);
    }

    private void showResults()
    {
            JList list = new JList();
            JScrollPane listPane = new JScrollPane();
            JPanel resultPanel = new JPanel();


            resultPanel.setLayout(new GridLayout(1,2));
            resultPanel.add(listPane);

            FactAddressValue state = (FactAddressValue)((MultifieldValue) clips.eval("(find-all-facts ((?f UI-state)) TRUE)")).listValue().get(0);
            MultifieldValue items = (MultifieldValue) state.getFactSlot("items");
            java.util.List itemsList = items.listValue();

            String[] names = new String[itemsList.size()];
            Iterator itr = itemsList.iterator();

            for(int i = 0; i < itemsList.size(); i++)
            {
                PrimitiveValue bv = (PrimitiveValue) itr.next();
                names[i] = res.getString(bv.toString());
            }

            list.setListData(names);
            list.setFixedCellWidth(280);
            list.setLayoutOrientation(JList.VERTICAL);
            list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

            listPane.getViewport().add(list);
            listPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);

            choicesPanel.add(resultPanel);
            choicesPanel.repaint();
    }

    public static void main(String[] args)
    {
        SwingUtilities.invokeLater(new Runnable()
                {
                public void run(){new Pakowanie();}
                });

    }

}
